---
title: MediaStreamConstraints.audio
slug: Web/API/MediaStreamConstraints/audio
tags:
  - API
  - Audio
  - Constraints
  - Dictionary
  - Interface
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaStreamConstraints
  - Reference
  - Web
  - WebRTC
  - getusermedia
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The {{domxref("MediaStreamConstraints")}} dictionary's <strong><code>audio</code></strong> property is used to indicate what kind of audio track, if any, should be included in the {{domxref("MediaStream")}} returned by a call to {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}.</p>

<p>To learn more about how constraints work, see <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>audioConstraints</em> = true | false | <em>MediaTrackConstraints</em>;
</pre>

<h3 id="Value">Value</h3>

<p>The value of the <code>audio</code> property can be specified as either of two types:</p>

<dl>
 <dt>{{jsxref("Boolean")}}</dt>
 <dd>If a Boolean value is specified, it indicates whether or not an audio track should be included in the returned stream; if it's <code>true</code>, an audio track is included; if no audio source is available or if permission is not given to use the audio source, the call to <code>getUserMedia()</code> will fail. If <code>false</code>, no audio track is included.</dd>
 <dt>{{domxref("MediaTrackConstraints")}}</dt>
 <dd>A constraints dictionary detailing the preferable and/or required values or ranges of values for the track's constrainable properties. If you specify constraints, an audio track meeting the constraints is required.</dd>
</dl>

<h2 id="Example">Examples</h2>

<p>For browsers with <a href="/en-US/docs/Web/HTTP/Feature_Policy">Feature Policy</a> enabled, the samples below need the <code>microphone</code> feature enabled. See {{SectionOnPage("/en-US/docs/Web/API/MediaDevices/getUserMedia", "Security")}} for details and examples on how to configure this.</p>

<h3 id="Using_a_Boolean_value">Using a Boolean value</h3>

<p>In this example, we provide a simple value of <code>true</code> for the <code>audio</code> property. This tells <code>getUserMedia()</code> that we require an audio track, but we don't care about any specifics beyond that.</p>

<div class="hidden">
<h4 id="HTML_content">HTML content</h4>

<pre class="brush: html">&lt;p&gt;Click the start button below to begin the demonstration.&lt;/p&gt;
&lt;div id="startButton" class="button"&gt;
  Start
&lt;/div&gt;
&lt;audio id="audio" autoplay controls&gt;&lt;/audio&gt;&lt;br&gt;
&lt;div id="log"&gt;&lt;/div&gt;</pre>

<h4 id="CSS_content">CSS content</h4>

<pre class="brush: css">body {
  font: 14px "Open Sans", "Arial", sans-serif;
}

audio {
  margin-top: 20px;
  border: 1px solid black;
  width: 160px;
}

.button {
  cursor: pointer;
  width: 160px;
  border: 1px solid black;
  font-size: 16px;
  text-align: center;
  padding-top: 2px;
  padding-bottom: 4px;
  color: white;
  background-color: darkgreen;
}</pre>

<h4 id="JavaScript_content">JavaScript content</h4>

<pre class="brush: js">let audioElement = document.getElementById("audio");
let logElement = document.getElementById("log");

function log(msg) {
 logElement.innerHTML += msg + "&lt;br&gt;";
}
</pre>
</div>

<pre class="brush: js">document.getElementById("startButton").addEventListener("click", function() {
  navigator.mediaDevices.getUserMedia({
    audio: true
  }).then(stream =&gt; audioElement.srcObject = stream)
    .catch(err =&gt; log(err.name + ": " + err.message));
}, false);</pre>

<p>Here we see an event handler for a {{domxref("click")}} event which uses {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} to obtain an audio-only stream with no specific constraints, then attaches the resulting stream to an {{HTMLElement("audio")}} element once the stream is returned.</p>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Using_a_Boolean_value', 600, 180, "", "", "", "microphone") }}</p>

<h3 id="Using_a_MediaTrackConstraints_object">Using a MediaTrackConstraints object</h3>

<p>Now let's look at a similar example that uses a set of constraints based on the {{domxref("MediaTrackConstraints")}} dictionary:</p>

<div class="hidden">
<h4 id="HTML_content_2">HTML content</h4>

<pre class="brush: html">&lt;p&gt;Click the start button below to begin the demonstration.&lt;/p&gt;
&lt;div id="startButton" class="button"&gt;
  Start
&lt;/div&gt;
&lt;audio id="audio" autoplay controls&gt;&lt;/audio&gt;&lt;br&gt;
&lt;div id="log"&gt;&lt;/div&gt;</pre>

<h4 id="CSS_content_2">CSS content</h4>

<pre class="brush: css">body {
  font: 14px "Open Sans", "Arial", sans-serif;
}

audio {
  margin-top: 20px;
  border: 1px solid black;
  width: 160px;
}

.button {
  cursor: pointer;
  width: 160px;
  border: 1px solid black;
  font-size: 16px;
  text-align: center;
  padding-top: 2px;
  padding-bottom: 4px;
  color: white;
  background-color: darkgreen;
}</pre>

<h4 id="JavaScript_content_2">JavaScript content</h4>

<pre class="brush: js">let audioElement = document.getElementById("audio");
let logElement = document.getElementById("log");

function log(msg) {
 logElement.innerHTML += msg + "&lt;br&gt;";
}
</pre>
</div>

<pre class="brush: js">document.getElementById("startButton").addEventListener("click", function() {
  navigator.mediaDevices.getUserMedia({
    audio: {
      sampleSize: 8,
      echoCancellation: true
    }
  }).then(stream =&gt; audioElement.srcObject = stream)
    .catch(err =&gt; log(err.name + ": " + err.message));
}, false);</pre>

<p>Here we see an event handler for a {{domxref("Element.click_event", "click")}} event which calls {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}, specifying a set of audio constraints requesting that echo cancellation be enabled and that, if possible, the sample rate be 8 bits per sample instead of the more common 16 bits (possibly as a bandwidth saving measure). As long as an audio input device is available and the user allows it to be used, an audio track will be included in the resulting stream, and it will match the specified constraints as well as possible.</p>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Using_a_MediaTrackConstraints_object', 600, 180, "", "", "", "microphone") }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Media Capture', '#dom-mediastreamconstraints-audio', 'MediaStreamConstraints.audio') }}</td>
   <td>{{ Spec2('Media Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamConstraints.audio")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("MediaDevices.getUserMedia()")}}</li>
 <li>{{domxref("MediaDevices.getSupportedConstraints()")}}</li>
 <li>{{domxref("MediaTrackSupportedConstraints")}}</li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
</ul>
